#include <gd.h>
#include <stdlib.h>
#include <stdio.h>
#include <stdint.h>

//This is a small header that's sent over the http connection before the actual bitmap data.
struct __attribute__ ((__packed__)) EinkHeader {
	uint8_t ver;                    //Header version. Only v1 is supported atm.
	uint16_t sleeptime;             //sleep time, in seconds
	uint8_t bmtype;                 //bitmap type. Only 0 (1bpp, full refresh) is supported for now. Ignored.
};

#define IMH 600
#define IMW 800

int main(int argc, char **argv) {
	FILE *fin;
	gdImagePtr im;
	int x,y,z,b, c, dif;
	char buf[IMH*IMW]; //Too big, I guess.
	char *bufp=buf;
	struct EinkHeader hdr;
	if (argc!=3) {
		printf("Usage: %s image.png sleeptime_in_secs\n", argv[0]);
		exit(1);
	}
	fin=fopen(argv[1], "r");
	if (fin==NULL) {
		perror(argv[1]);
		exit(1);
	}
	im=gdImageCreateFromPng(fin);
	if (im==NULL) {
		printf("Error loading png\n");
		exit(1);
	}
	hdr.ver=1;
	hdr.sleeptime=atoi(argv[2]);
	hdr.bmtype=0;
	dif=32;
	for (y=0; y<IMH; y++) {
		for (x=0; x<IMW; x+=8) {
			b=0;
			for (z=0; z<8; z++) {
				b<<=1;
				c=gdImageGetPixel(im, x+z, y);
				//ToDo: truecolor?
				if ((int)gdImageGreen(im, c)<128+dif) b|=1;
//				fprintf(stderr, "%i ", gdImageGreen(im, c));
				dif=-dif;
			}
			*bufp++=b;
		}
		dif=-dif;
	}
	fwrite(&hdr, sizeof(hdr), 1, stdout);
	fwrite(buf, bufp-buf, 1, stdout);
}
